
  --/////////---\\\\\\\\\---/////////---\\\\\\\--
  
  -----------------------------------------------
  show_audio_on_tcp = false
  number_of_channel_in_names = true
  -----------------------------------------------
  
  ---color for audio track-----------------------
  R_a = 0   ---Red
  G_a = 0   ---Green
  B_a = 0   ---Blue
  -----------------------------------------------
  
  --\\\\\\\\\---/////////---\\\\\\\\\---///////--

  function bla() end
  function nothing() reaper.defer(bla) end
  
  if (show_audio_on_tcp ~= true and show_audio_on_tcp ~= false)
  or (number_of_channel_in_names ~= true and number_of_channel_in_names ~= false) 
  then
    reaper.MB
    (
    'Incorrect value for "show_audio_on_tcp" ' .. 
    'or "number_of_channel_in_names". Set the boolen - "true" or "false"',
    'Error',0
    ) 
    nothing() return
  end
  
  local test_SWS = reaper.NF_GetMediaItemPeakRMS_Windowed --function added in 2.9.7 SWS
  if not test_SWS then
    reaper.MB('Please install or update SWS extension', 'Error', 0) nothing() return
  end
  
  if reaper.CountSelectedTracks(0) > 0 then
  
    ::START::
    local retval, value = reaper.GetUserInputs
    (
    'Create audio track from multich VSTi', 2, 
    'Set the audio name:,Set channel as midi (1-16):', ","
    )
    
    if retval then
      
      reaper.Undo_BeginBlock()
      reaper.PreventUIRefresh(1)
      
      local t = {}
      for s in string.gmatch(value,'[^,]+') do
        table.insert(t,s)
      end
      
      if #t ~= 2 then
        reaper.MB('Incorrect value or no value. Set the correct value for any line', 'Error', 0) 
        goto START 
      end        
      
      name = t[1]
      channel = t[2]
      
      if channel ~= string.match(channel,'%d+')
      or (tonumber(channel) < 1 or tonumber(channel) > 16) 
      then 
        reaper.MB('Incorrect value. Set the correct midi channel (1-16)', 'Error', 0) 
        goto START 
      end
      
      
      function convert_bool(bool)
        if bool == false then
          bool = 0
        else 
          bool = 1
        end
        return bool
      end
      
      for i = 0, reaper.CountSelectedTracks(0)-1 do
        local get_instrument_track = reaper.GetSelectedTrack(0,i)
        local instrument_track_num = reaper.GetMediaTrackInfo_Value(get_instrument_track,'IP_TRACKNUMBER')
        if reaper.GetMediaTrackInfo_Value(get_instrument_track,'I_NCHAN') < tonumber(channel)*2 then
          reaper.SetMediaTrackInfo_Value(get_instrument_track,'I_NCHAN', tonumber(channel)*2)
        end
        if reaper.GetMediaTrackInfo_Value(get_instrument_track,'B_MAINSEND') == 1 then
          reaper.SetMediaTrackInfo_Value(get_instrument_track,'B_MAINSEND', 0)
        end
        
        reaper.InsertTrackAtIndex(instrument_track_num-1,false)
        local get_audio_track = reaper.GetTrack(0,instrument_track_num-1)
        if number_of_channel_in_names == true then
          reaper.GetSetMediaTrackInfo_String(get_audio_track, 'P_NAME', name .. ' - '.. channel .. ' st', true)
        else 
          reaper.GetSetMediaTrackInfo_String(get_audio_track, 'P_NAME', name, true)
        end
        reaper.SetMediaTrackInfo_Value(get_audio_track, 'B_SHOWINTCP', convert_bool(show_audio_on_tcp))
        if R_a == 0 and G_a == 0 and B_a == 0 then
          nothing()
        else
          reaper.SetTrackColor(get_audio_track, reaper.ColorToNative(R_a,G_a,B_a)|0x1000000)
        end
        reaper.CreateTrackSend(get_instrument_track, get_audio_track)
        reaper.BR_GetSetTrackSendInfo(get_audio_track, -1, 0, 'I_MIDI_SRCCHAN', true, -1)
        reaper.SetTrackSendInfo_Value(get_audio_track, -1, 0, 'I_SRCCHAN', 2*(tonumber(channel)-1))
      end
    
      reaper.Undo_EndBlock('Create only audio track from multichannel VSTi (track)', -1)
      reaper.PreventUIRefresh(-1)
      
    else 
      nothing() return 
    end
    
  else 
    reaper.MB('Please select a track', 'Error',0) 
    nothing()
  end
  

