
  --///////////|||\\\\\\\\\\\---Customize this---///////////|||\\\\\\\\\\--
  
  ---some parameters for tracks--------------------------------------------
    show_midi_on_mcp = false
    number_of_channel_in_names = true
  -------------------------------------------------------------------------
  
  ---color for midi track--------------------------------------------------
    R_m = 0    ---Red
    G_m = 0    ---Green
    B_m = 0    ---Blue
  -------------------------------------------------------------------------
  
  --\\\\\\\\\\\|||///////////---//////||\\\\\\---\\\\\\\\\\\|||//////////--


  --///////////-----------------------------------------------\\\\\\\\\\\--
  --===========---RUN SCRIPT--START START START--RUN SCRIPT---===========--
  --\\\\\\\\\\\-----------------------------------------------///////////--
  

  function bla() end
  function nothing() reaper.defer(bla) end

  if (show_midi_on_mcp ~= true and show_midi_on_mcp ~= false)
  or (number_of_channel_in_names ~= true and number_of_channel_in_names ~= false) 
  then
    reaper.MB
    (
    'Incorrect value for "show_midi_on_mcp" or "number_of_channel_in_names". Set the boolen - "true" or "false"',
    'Error',0
    ) 
    nothing() return
  end
  
  local test_SWS = reaper.NF_GetMediaItemPeakRMS_Windowed --function added in 2.9.7 SWS
  if not test_SWS then
    reaper.MB('Please install or update SWS extension', 'Error', 0) nothing() return
  end
    
  if reaper.CountSelectedTracks(0) > 0 then
  
    ::START::
    local retval, value = reaper.GetUserInputs
    (
    'Create MIDI track from multich VSTi', 
    2, 'Set the MIDI track name:,Set channel (0-16):', ","
    )
    
    if retval then
      
      reaper.Undo_BeginBlock()
      reaper.PreventUIRefresh(1)
      
      local t = {}
      for s in string.gmatch(value,'[^,]+') do
        table.insert(t,s)
      end
      
      if #t ~= 2 then
        reaper.MB('Incorrect value or no value. Set the correct value for any line', 'Error', 0) 
        goto START 
      end        
      
      name = t[1]
      channel = t[2]
      
      if channel ~= string.match(channel,'%d+')
      or (tonumber(channel) < 0 or tonumber(channel) > 16) 
      then 
        reaper.MB('Incorrect value. Set the correct midi channel (0-16)', 'Error', 0) 
        goto START 
      end
      
      booln = true
      name_tr = channel
      if channel == '0' then
        name_tr = 'All'
        booln = false
      end
      
      function convert_bool(bool)
        if bool == false then
          bool = 0
        else 
          bool = 1
        end
        return bool
      end
    
    
    --START-CyCLe----START-CyCLe----START-CyCLe----START-CyCLe--
      for i = 0, reaper.CountSelectedTracks(0)-1 do
    ------------------------------------------------------------  
      
        --START--//////////////////////---Get instrument track and set send properties---\\\\\\\\\\\\\\\\\\\\\\\\\\\\\--
            local get_instrument_track = reaper.GetSelectedTrack(0,i)
            local instrument_track_num = reaper.GetMediaTrackInfo_Value(get_instrument_track,'IP_TRACKNUMBER')
        ---END---\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\--------/////////////////////////////////////////////////////--
      
          
        --START--/////////////////////---Insert MIDI track and set send properties---\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\--
            reaper.InsertTrackAtIndex(instrument_track_num-1,false)
            local get_midi_track = reaper.GetTrack(0,instrument_track_num-1)
            
            if number_of_channel_in_names == true then
              reaper.GetSetMediaTrackInfo_String(get_midi_track, 'P_NAME', name .. ' - ' .. name_tr .. ' ch', true)
            else
              reaper.GetSetMediaTrackInfo_String(get_midi_track, 'P_NAME', name, true)
            end
            
            if reaper.GetMediaTrackInfo_Value(get_midi_track, 'I_RECMON') == 0 then
              reaper.SetMediaTrackInfo_Value(get_midi_track, 'I_RECMON', 1)
            end
            
            reaper.SetMediaTrackInfo_Value(get_midi_track, 'B_SHOWINMIXER', convert_bool(show_midi_on_mcp))
            
            if R_m == 0 and G_m == 0 and B_m == 0 then
              nothing()
            else
              reaper.SetTrackColor(get_midi_track, reaper.ColorToNative(R_m,G_m,B_m)|0x1000000)
            end
            
            reaper.CreateTrackSend(get_midi_track, get_instrument_track)
            reaper.SetTrackSendInfo_Value(get_midi_track, 0, 0, 'I_SRCCHAN', -1)
            
            if booln == true then
              reaper.SetTrackSendInfo_Value(get_midi_track, 0, 0, 'I_MIDIFLAGS', tonumber(channel) << 5)
            else  
              reaper.SetTrackSendInfo_Value(get_midi_track, 0, 0, 'I_MIDIFLAGS', 0)
            end
        ---END---\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\--------///////////////////////////////////////////////////--
    
    --END-CyCLe----END-CyCLe--
      end
    --------------------------
    
      reaper.Undo_EndBlock('Create midi track from multichannel VSTi (track)', -1)
      reaper.PreventUIRefresh(-1)
      
    else 
      nothing() return 
    end
    
  else 
    reaper.MB('Please select a track', 'Error',0) 
    nothing()
  end
  

